#!/usr/bin/env python

print("importing libs...")
from skimage import img_as_ubyte
from skimage.color import rgb2gray
import cv2, imutils, time
from imutils.video import VideoStream
from keras.models import load_model

print("load model...")
model=load_model('MNIST_trained_model_RasPi401_30_epochs__001.h5')
model.summary()

vs=VideoStream(usePiCamera=["picamera"]).start()
time.sleep(1.0)

while True:
    frame=vs.read()
    frame=imutils.resize(frame, width=400)
    cv2.imshow("press 'a' to analyze - 'q' to quit", frame)
    key=cv2.waitKey(1)&0xFF
    if key == ord("a"):
        img_gray=rgb2gray(frame)
        img_gray_u8=img_as_ubyte(img_gray)
        
        (thresh, img_bw)=cv2.threshold(img_gray_u8,128,255,cv2.THRESH_BINARY|cv2.THRESH_OTSU)
        img_resized=cv2.resize(img_bw,(28,28))
        img_gray_invert=255-img_resized
        cv2.imshow("gray", img_gray_invert)
        img_final=img_gray_invert.reshape(1,28,28,1)
        ans = model.predict(img_final)
        print(ans)
        ans = ans[0].tolist().index(max(ans[0].tolist()))
        print('reading digit as: ',ans)
        print("=================================")    
    if key == ord("q"):
        break
cv2.destroyAllWindows()
vs.stop()
print("bye...")

